
#include <Windows.h>
#include <cstdio>
#include <cstring>
#include <vector>

#define ID_OBUTTON    1001
#define ID_XBUTTON    1002
#define ID_NEXTBUTTON 1003
#define ID_BACKBUTTON 1004

using namespace std;

namespace myqma {

    struct QuestionData {
        wchar_t Text[1000];
        int TextLength;
        int Answer;
    };

    vector<QuestionData> Questions;
    int QuestionNumber = 0;
    LPCWSTR ClassName = L"wc_myqma";
    LPCWSTR ApplicationName = L"QMAKvO";
    LPCWSTR QuestionFileName = L"question.txt";

    // EBhEvV[W
    LRESULT CALLBACK WndProc( HWND window, UINT message, WPARAM wp, LPARAM lp ) {
        switch( message ) {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            break;
        case WM_COMMAND: // {^ꂽ̓
            if( LOWORD(wp)==ID_OBUTTON&&Questions[QuestionNumber].Answer==0 || LOWORD(wp)==ID_XBUTTON&&Questions[QuestionNumber].Answer==1 ) {
                MessageBox( window, L"I", ApplicationName, MB_OK );
            } else if( LOWORD(wp)==ID_OBUTTON&&Questions[QuestionNumber].Answer==1 || LOWORD(wp)==ID_XBUTTON&&Questions[QuestionNumber].Answer==0 ) {
                MessageBox( window, L"s...", ApplicationName, MB_OK );
            } else {
                switch( LOWORD(wp) ) {
                case ID_NEXTBUTTON:
                    ++QuestionNumber;
                    if( QuestionNumber >= Questions.size() ) QuestionNumber = Questions.size() - 1;
                    InvalidateRect( window, NULL, TRUE );
                    break;
                case ID_BACKBUTTON:
                    --QuestionNumber;
                    if( QuestionNumber < 0 ) QuestionNumber = 0;
                    InvalidateRect( window, NULL, TRUE );
                    break;
                }
            }
            break;
        case WM_PAINT: // 蕶`悷
            {
                PAINTSTRUCT ps;
                HDC hdc;
                hdc = BeginPaint( window, &ps );
                TextOut( hdc, 10, 10, Questions[QuestionNumber].Text, Questions[QuestionNumber].TextLength );
                EndPaint( window, &ps );
            }
            break;
        default:
            return DefWindowProc( window, message, wp, lp );
        }
        return 0;
    }

    // t@C蕶ǂݍ
    bool LoadQuestionFile() {
        FILE *fp;
        wchar_t temporary[1000];
        _wfopen_s( &fp, QuestionFileName, L"rt, ccs=UTF-16LE" );
        if( fp == NULL ) {
            MessageBox( NULL, L"t@Cǂݍ߂܂ł", ApplicationName, MB_OK );
            return false;
        }
        QuestionData item;
        Questions.clear();
        while( !feof( fp ) ) {
            if( NULL == fgetws( item.Text, sizeof(item.Text)/sizeof(item.Text[0]), fp ) )
                break;
            item.TextLength = wcsnlen( item.Text, sizeof(item.Text)/sizeof(item.Text[0]) );
            item.Text[item.TextLength--] = L'\0';
            if( NULL == fgetws( temporary, sizeof(temporary)/sizeof(temporary[0]), fp ) )
                break;
            if( temporary[0] == L'0' ) {
                item.Answer = 0;
            } else if( temporary[0] == L'1' ) {
                item.Answer = 1;
            } else {
                MessageBox( NULL, L"̒`sł", ApplicationName, MB_OK );
                fclose( fp );
                return false;
            }
            Questions.push_back( item );
        }
        fclose( fp );
        if( Questions.size() == 0 ) {
            MessageBox( NULL, L"肪1܂", ApplicationName, MB_OK );
            return false;
        }
        return true;
    }

    // EBhEE\
    HWND PrepareWindow( HINSTANCE instance, int cmdshow ) {
        // EBhENX̍쐬
        WNDCLASSEX windowclass;
        ZeroMemory( &windowclass, sizeof(windowclass) );
        windowclass.cbSize = sizeof(windowclass);
        windowclass.hInstance = instance;
        windowclass.lpszClassName = ClassName;
        windowclass.lpfnWndProc = WndProc;
        windowclass.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
        windowclass.hCursor = LoadCursor( NULL, IDC_ARROW );
        if( 0 == RegisterClassEx( &windowclass ) ) {
            MessageBox( NULL, L"EBhENX̓o^Ɏs", ApplicationName, MB_OK );
            return NULL;
        }
        // EBhE̍쐬
        HWND mywindow;
        RECT windowrect = { 0, 0, 400, 300 };
        AdjustWindowRect( &windowrect, WS_OVERLAPPEDWINDOW, FALSE );
        mywindow = CreateWindow( ClassName,
            ApplicationName,
            WS_OVERLAPPEDWINDOW,
            CW_USEDEFAULT, CW_USEDEFAULT,
            windowrect.right-windowrect.left, windowrect.bottom-windowrect.top,
            NULL, NULL, instance, NULL );
        CreateWindow( L"BUTTON", L"", WS_CHILD|WS_VISIBLE,
             80, 120, 100, 100, mywindow, (HMENU)ID_OBUTTON, instance, NULL );
        CreateWindow( L"BUTTON", L"~", WS_CHILD|WS_VISIBLE,
            220, 120, 100, 100, mywindow, (HMENU)ID_XBUTTON, instance, NULL );
        CreateWindow( L"BUTTON", L" >>", WS_CHILD|WS_VISIBLE,
            400-90, 300-40, 80, 30, mywindow, (HMENU)ID_NEXTBUTTON, instance, NULL );
        CreateWindow( L"BUTTON", L"<< O", WS_CHILD|WS_VISIBLE,
            400-90-90, 300-40, 80, 30, mywindow, (HMENU)ID_BACKBUTTON, instance, NULL );
        ShowWindow( mywindow, cmdshow|SW_SHOW );
        return mywindow;
    }

    extern "C" int WINAPI wWinMain( HINSTANCE instance, HINSTANCE prev_instance, LPWSTR commandline, int cmdshow ) {
        HWND mainwindow;
        if( ! LoadQuestionFile() )
            return 1;
        mainwindow = PrepareWindow( instance, cmdshow );
        if( mainwindow == NULL )
            return 1;
        // bZ[W[v
        MSG message;
        while( GetMessage( &message, NULL, 0, 0 ) ) {
            DispatchMessage( &message );
        }
        DestroyWindow( mainwindow );
        return message.wParam;
    }
}

